# Channel

The Channel class provides a wrapper for interacting with RabbitMQ implementing the methods and behaviors for an AMQP Channel.

## Channel

class `pika.channel.``Channel`(connection, channel_number, on_open_callback)

  A Channel is the primary communication method for interacting with RabbitMQ. It is recommended that you do not directly invoke the creation of a channel object in your application code but rather construct the a channel by calling the active connection’s channel() method.

  `add_callback`(callback, replies, one_shot=True)

    Pass in a callback handler and a list replies from the RabbitMQ broker which you’d like the callback notified of. Callbacks should allow for the frame parameter to be passed in.

    Parameters:

    - callback (callable) – The callback to call
    - replies (list) – The replies to get a callback for
    - one_shot (bool) – Only handle the first type callback

  `add_on_cancel_callback`(callback)

    Pass a callback function that will be called when the basic_cancel is sent by the server. The callback function should receive a frame parameter.

    Parameters: | callback (callable) – The callback to call on Basic.Cancel from broker

  `add_on_close_callback`(callback)

    Pass a callback function that will be called when the channel is closed. The callback function will receive the channel, the reply_code (int) and the reply_text (int) describing why the channel was closed.

    If the channel is closed by broker via Channel.Close, the callback will receive the reply_code/reply_text provided by the broker.

    If channel closing is initiated by user (either directly of indirectly by closing a connection containing the channel) and closing concludes gracefully without Channel.Close from the broker and without loss of connection, the callback will receive 0 as reply_code and empty string as reply_text.

    If channel was closed due to loss of connection, the callback will receive reply_code and reply_text representing the loss of connection.

    Parameters: | callback (callable) – The callback, having the signature: callback(Channel, int reply_code, str reply_text)

  `add_on_flow_callback`(callback)

    Pass a callback function that will be called when Channel.Flow is called by the remote server. Note that newer versions of RabbitMQ will not issue this but instead use TCP backpressure

    Parameters: | callback (callable) – The callback function

  `add_on_return_callback`(callback)

    Pass a callback function that will be called when basic_publish as sent a message that has been rejected and returned by the server.

    Parameters: | callback (callable) – The function to call, having the signature callback(channel, method, properties, body) where channel: pika.Channel method: pika.spec.Basic.Return properties: pika.spec.BasicProperties body: str, unicode, or bytes (python 3.x)

  `basic_ack`(delivery_tag=0, multiple=False)

    Acknowledge one or more messages. When sent by the client, this method acknowledges one or more messages delivered via the Deliver or Get-Ok methods. When sent by server, this method acknowledges one or more messages published with the Publish method on a channel in confirm mode. The acknowledgement can be for a single message or a set of messages up to and including a specific message.

    Parameters:

    - delivery_tag (integer) – int/long The server-assigned delivery tag
    - multiple (bool) – If set to True, the delivery tag is treated as “up to and including”, so that multiple messages can be acknowledged with a single method. If set to False, the delivery tag refers to a single message. If the multiple field is 1, and the delivery tag is zero, this indicates acknowledgement of all outstanding messages.

  `basic_cancel`(callback=None, consumer_tag='', nowait=False)

    This method cancels a consumer. This does not affect already delivered messages, but it does mean the server will not send any more messages for that consumer. The client may receive an arbitrary number of messages in between sending the cancel method and receiving the cancel-ok reply. It may also be sent from the server to the client in the event of the consumer being unexpectedly cancelled (i.e. cancelled for any reason other than the server receiving the corresponding basic.cancel from the client). This allows clients to be notified of the loss of consumers due to events such as queue deletion.

    Parameters:

    - callback (callable) – Callback to call for a Basic.CancelOk response; MUST be None when nowait=True. MUST be callable when nowait=False.
    - consumer_tag (str) – Identifier for the consumer
    - nowait (bool) – Do not expect a Basic.CancelOk response

    Raises: | ValueError –

  `basic_consume`(consumer_callback, queue='', no_ack=False, exclusive=False, consumer_tag=None, arguments=None)

    Sends the AMQP 0-9-1 command Basic.Consume to the broker and binds messages for the consumer_tag to the consumer callback. If you do not pass in a consumer_tag, one will be automatically generated for you. Returns the consumer tag.

    For more information on basic_consume, see: Tutorial 2 at http://www.rabbitmq.com/getstarted.html http://www.rabbitmq.com/confirms.html http://www.rabbitmq.com/amqp-0-9-1-reference.html#basic.consume

    Parameters:

    - consumer_callback (callable) –

      The function to call when consuming with the signature consumer_callback(channel, method, properties,

      > > body), where

      > channel: pika.Channel method: pika.spec.Basic.Deliver properties: pika.spec.BasicProperties body: str, unicode, or bytes (python 3.x)

    - queue (str or unicode) – The queue to consume from
    - no_ack (bool) – if set to True, automatic acknowledgement mode will be used (see http://www.rabbitmq.com/confirms.html)
    - exclusive (bool) – Don’t allow other consumers on the queue
    - consumer_tag (str or unicode) – Specify your own consumer tag
    - arguments (dict) – Custom key/value pair arguments for the consumer

    Return type: | str

  `basic_get`(callback=None, queue='', no_ack=False)

    Get a single message from the AMQP broker. If you want to be notified of Basic.GetEmpty, use the Channel.add_callback method adding your Basic.GetEmpty callback which should expect only one parameter, frame. Due to implementation details, this cannot be called a second time until the callback is executed. For more information on basic_get and its parameters, see:

    http://www.rabbitmq.com/amqp-0-9-1-reference.html#basic.get

    Parameters:

    - callback (callable) – The callback to call with a message that has the signature callback(channel, method, properties, body), where: channel: pika.Channel method: pika.spec.Basic.GetOk properties: pika.spec.BasicProperties body: str, unicode, or bytes (python 3.x)
    - queue (str or unicode) – The queue to get a message from
    - no_ack (bool) – Tell the broker to not expect a reply

  `basic_nack`(delivery_tag=None, multiple=False, requeue=True)

    This method allows a client to reject one or more incoming messages. It can be used to interrupt and cancel large incoming messages, or return untreatable messages to their original queue.

    Parameters:

    - delivery-tag (integer) – int/long The server-assigned delivery tag
    - multiple (bool) – If set to True, the delivery tag is treated as “up to and including”, so that multiple messages can be acknowledged with a single method. If set to False, the delivery tag refers to a single message. If the multiple field is 1, and the delivery tag is zero, this indicates acknowledgement of all outstanding messages.
    - requeue (bool) – If requeue is true, the server will attempt to requeue the message. If requeue is false or the requeue attempt fails the messages are discarded or dead-lettered.

  `basic_publish`(exchange, routing_key, body, properties=None, mandatory=False, immediate=False)

    Publish to the channel with the given exchange, routing key and body. For more information on basic_publish and what the parameters do, see:

    http://www.rabbitmq.com/amqp-0-9-1-reference.html#basic.publish

    Parameters:

    - exchange (str or unicode) – The exchange to publish to
    - routing_key (str or unicode) – The routing key to bind on
    - body (str or unicode) – The message body
    - properties (pika.spec.BasicProperties) – Basic.properties
    - mandatory (bool) – The mandatory flag
    - immediate (bool) – The immediate flag

  `basic_qos`(callback=None, prefetch_size=0, prefetch_count=0, all_channels=False)

    Specify quality of service. This method requests a specific quality of service. The QoS can be specified for the current channel or for all channels on the connection. The client can request that messages be sent in advance so that when the client finishes processing a message, the following message is already held locally, rather than needing to be sent down the channel. Prefetching gives a performance improvement.

    Parameters:

    - callback (callable) – The callback to call for Basic.QosOk response
    - prefetch_size (int) – This field specifies the prefetch window size. The server will send a message in advance if it is equal to or smaller in size than the available prefetch size (and also falls into other prefetch limits). May be set to zero, meaning “no specific limit”, although other prefetch limits may still apply. The prefetch-size is ignored if the no-ack option is set.
    - prefetch_count (int) – Specifies a prefetch window in terms of whole messages. This field may be used in combination with the prefetch-size field; a message will only be sent in advance if both prefetch windows (and those at the channel and connection level) allow it. The prefetch-count is ignored if the no-ack option is set.
    - all_channels (bool) – Should the QoS apply to all channels

  `basic_recover`(callback=None, requeue=False)

    This method asks the server to redeliver all unacknowledged messages on a specified channel. Zero or more messages may be redelivered. This method replaces the asynchronous Recover.

    Parameters:

    - callback (callable) – Callback to call when receiving Basic.RecoverOk
    - requeue (bool) – If False, the message will be redelivered to the original recipient. If True, the server will attempt to requeue the message, potentially then delivering it to an alternative subscriber.

  `basic_reject`(delivery_tag, requeue=True)

    Reject an incoming message. This method allows a client to reject a message. It can be used to interrupt and cancel large incoming messages, or return untreatable messages to their original queue.

    Parameters:

    - delivery-tag (integer) – int/long The server-assigned delivery tag
    - requeue (bool) – If requeue is true, the server will attempt to requeue the message. If requeue is false or the requeue attempt fails the messages are discarded or dead-lettered.

    Raises: | TypeError

  `close`(reply_code=0, reply_text='Normal shutdown')

    Invoke a graceful shutdown of the channel with the AMQP Broker.

    If channel is OPENING, transition to CLOSING and suppress the incoming Channel.OpenOk, if any.

    Parameters:

    - reply_code (int) – The reason code to send to broker
    - reply_text (str) – The reason text to send to broker

    Raises:

    - ChannelClosed – if channel is already closed
    - ChannelAlreadyClosing – if channel is already closing

  `confirm_delivery`(callback=None, nowait=False)

    Turn on Confirm mode in the channel. Pass in a callback to be notified by the Broker when a message has been confirmed as received or rejected (Basic.Ack, Basic.Nack) from the broker to the publisher.

    For more information see:
      http://www.rabbitmq.com/extensions.html#confirms

    Parameters:

    - callback (callable) – The callback for delivery confirmations that has the following signature: callback(pika.frame.Method), where method_frame contains either method spec.Basic.Ack or spec.Basic.Nack.
    - nowait (bool) – Do not send a reply frame (Confirm.SelectOk)

  `consumer_tags`

    Property method that returns a list of currently active consumers

    Return type: | list

  `exchange_bind`(callback=None, destination=None, source=None, routing_key='', nowait=False, arguments=None)

    Bind an exchange to another exchange.

    Parameters:

    - callback (callable) – The callback to call on Exchange.BindOk; MUST be None when nowait=True
    - destination (str or unicode) – The destination exchange to bind
    - source (str or unicode) – The source exchange to bind to
    - routing_key (str or unicode) – The routing key to bind on
    - nowait (bool) – Do not wait for an Exchange.BindOk
    - arguments (dict) – Custom key/value pair arguments for the binding

  `exchange_declare`(callback=None, exchange=None, exchange_type='direct', passive=False, durable=False, auto_delete=False, internal=False, nowait=False, arguments=None)

    This method creates an exchange if it does not already exist, and if the exchange exists, verifies that it is of the correct and expected class.

    If passive set, the server will reply with Declare-Ok if the exchange already exists with the same name, and raise an error if not and if the exchange does not already exist, the server MUST raise a channel exception with reply code 404 (not found).

    Parameters:

    - callback (callable) – Call this method on Exchange.DeclareOk; MUST be None when nowait=True
    - exchange (str or unicode sequence of these characters: letters, digits, hyphen, underscore, period, or colon.) – The exchange name consists of a non-empty
    - exchange_type (str) – The exchange type to use
    - passive (bool) – Perform a declare or just check to see if it exists
    - durable (bool) – Survive a reboot of RabbitMQ
    - auto_delete (bool) – Remove when no more queues are bound to it
    - internal (bool) – Can only be published to by other exchanges
    - nowait (bool) – Do not expect an Exchange.DeclareOk response
    - arguments (dict) – Custom key/value pair arguments for the exchange

  `exchange_delete`(callback=None, exchange=None, if_unused=False, nowait=False)

    Delete the exchange.

    Parameters:

    - callback (callable) – The function to call on Exchange.DeleteOk; MUST be None when nowait=True.
    - exchange (str or unicode) – The exchange name
    - if_unused (bool) – only delete if the exchange is unused
    - nowait (bool) – Do not wait for an Exchange.DeleteOk

  `exchange_unbind`(callback=None, destination=None, source=None, routing_key='', nowait=False, arguments=None)

    Unbind an exchange from another exchange.

    Parameters:

    - callback (callable) – The callback to call on Exchange.UnbindOk; MUST be None when nowait=True.
    - destination (str or unicode) – The destination exchange to unbind
    - source (str or unicode) – The source exchange to unbind from
    - routing_key (str or unicode) – The routing key to unbind
    - nowait (bool) – Do not wait for an Exchange.UnbindOk
    - arguments (dict) – Custom key/value pair arguments for the binding

  `flow`(callback, active)

    Turn Channel flow control off and on. Pass a callback to be notified of the response from the server. active is a bool. Callback should expect a bool in response indicating channel flow state. For more information, please reference:

    http://www.rabbitmq.com/amqp-0-9-1-reference.html#channel.flow

    Parameters:

    - callback (callable) – The callback to call upon completion
    - active (bool) – Turn flow on or off

  `is_closed`

    Returns True if the channel is closed.

    Return type: | bool

  `is_closing`

    Returns True if client-initiated closing of the channel is in progress.

    Return type: | bool

  `is_open`

    Returns True if the channel is open.

    Return type: | bool

  `open`()

    Open the channel

  `queue_bind`(callback, queue, exchange, routing_key=None, nowait=False, arguments=None)

    Bind the queue to the specified exchange

    Parameters:

    - callback (callable) – The callback to call on Queue.BindOk; MUST be None when nowait=True.
    - queue (str or unicode) – The queue to bind to the exchange
    - exchange (str or unicode) – The source exchange to bind to
    - routing_key (str or unicode) – The routing key to bind on
    - nowait (bool) – Do not wait for a Queue.BindOk
    - arguments (dict) – Custom key/value pair arguments for the binding

  `queue_declare`(callback, queue='', passive=False, durable=False, exclusive=False, auto_delete=False, nowait=False, arguments=None)

    Declare queue, create if needed. This method creates or checks a queue. When creating a new queue the client can specify various properties that control the durability of the queue and its contents, and the level of sharing for the queue.

    Leave the queue name empty for a auto-named queue in RabbitMQ

    Parameters:

    - callback (callable) – callback(pika.frame.Method) for method Queue.DeclareOk; MUST be None when nowait=True.
    - queue (str or unicode) – The queue name
    - passive (bool) – Only check to see if the queue exists
    - durable (bool) – Survive reboots of the broker
    - exclusive (bool) – Only allow access by the current connection
    - auto_delete (bool) – Delete after consumer cancels or disconnects
    - nowait (bool) – Do not wait for a Queue.DeclareOk
    - arguments (dict) – Custom key/value arguments for the queue

  `queue_delete`(callback=None, queue='', if_unused=False, if_empty=False, nowait=False)

    Delete a queue from the broker.

    Parameters:

    - callback (callable) – The callback to call on Queue.DeleteOk; MUST be None when nowait=True.
    - queue (str or unicode) – The queue to delete
    - if_unused (bool) – only delete if it’s unused
    - if_empty (bool) – only delete if the queue is empty
    - nowait (bool) – Do not wait for a Queue.DeleteOk

  `queue_purge`(callback=None, queue='', nowait=False)

    Purge all of the messages from the specified queue

    Parameters:

    - callback (callable) – The callback to call on Queue.PurgeOk; MUST be None when nowait=True.
    - queue (str or unicode) – The queue to purge
    - nowait (bool) – Do not expect a Queue.PurgeOk response

  `queue_unbind`(callback=None, queue='', exchange=None, routing_key=None, arguments=None)

    Unbind a queue from an exchange.

    Parameters:

    - callback (callable) – The callback to call on Queue.UnbindOk
    - queue (str or unicode) – The queue to unbind from the exchange
    - exchange (str or unicode) – The source exchange to bind from
    - routing_key (str or unicode) – The routing key to unbind
    - arguments (dict) – Custom key/value pair arguments for the binding

  `tx_commit`(callback=None)

    Commit a transaction

    Parameters: | callback (callable) – The callback for delivery confirmations

  `tx_rollback`(callback=None)

    Rollback a transaction.

    Parameters: | callback (callable) – The callback for delivery confirmations

  `tx_select`(callback=None)

    Select standard transaction mode. This method sets the channel to use standard transactions. The client must use this method at least once on a channel before using the Commit or Rollback methods.

    Parameters: | callback (callable) – The callback for delivery confirmations